<?php
//
// Project   : asterweb / asterwebmod.inc.php
// Written By: David Cornewell
// Purpose   : Allows for loading of optional modules into asterweb.
//

$asterwebmods = array();

class AsterwebModule {
	var $name;
	var $title;
	var $handlerfunc;
	var $admin;
	
	function AsterwebModule($name,$title,$handlerfunc,$admin)
	{
		$this->name=$name;
		$this->title=$title;
		$this->handlerfunc=$handlerfunc;
		$this->admin=$admin;
	}
}

function Asterwebmod_AddModule($name,$title,$handlerfunc,$admin)
{
	global $asterwebmods;
	$asterwebmods[$name] = new AsterwebModule($name,$title,$handlerfunc,$admin);
}

function Asterwebmod_GetModule($name)
{
	global $asterwebmods;
	return $asterwebmods[$name];
}

function Asterwebmod_GetAllModules()
{
	global $asterwebmods;
	return $asterwebmods;
}

$dir=opendir("modules");
if ($dir) {
	while ( ($file=readdir($dir)) ) {
		if (strpos($file,".mod.php") !=false) {
			require_once("modules/".$file);
		}
	}
	
	closedir($dir);
}

?>
