<?php
/* This is the mysql plugin for asteriskdbconf
 *
 * Created By David Cornewell
*/

function DBConnect($db_server,$db_user,$db_pass,$db_name)
{
	$conn = mysql_connect($db_server,$db_user,$db_pass) or die;
	mysql_select_db($db_name, $conn);
	return $conn;
}

function DBClose($conn)
{
	mysql_close($conn);
}

function DBErrorMsg()
{
	return mysql_error();
}

function DBQuery($sql, $conn)
{
	return mysql_query ($sql,$conn);
}
 
function DBGetRow($result)
{
	return mysql_fetch_array($result);
}

function DBNumRows($result)
{
	return mysql_num_rows($result);
}

function DBInsertID($conn)
{
	return mysql_insert_id($conn);
}

function DBFreeResult($result)
{
	return mysql_free_result($result);
}

function SipUser_DBQry($conn, $where)
{
	$sql = "SELECT s.id,s.name,s.accountcode,s.amaflags,s.callgroup,s.callerid,s.canreinvite,s.context,s.defaultip,s.dtmfmode,s.fromuser,s.".
			"fromdomain,s.host,s.insecure,s.language,s.mailbox,s.md5secret,s.nat,s.permit,s.deny,s.mask,s.pickupgroup,s.port,s.qualify,s.".
			"restrictcid,s.rtptimeout,s.rtpholdtimeout,s.secret,s.type,s.username,s.disallow,s.allow,s.musiconhold,s.regseconds,s.ipaddr,s.".
			"regexten,s.cancallforward, v.uniqueid,v.email,v.fullname,v.pager,v.customer_id,v.stamp ".
			" FROM sip_buddies s LEFT JOIN voicemail_users v ON s.mailbox=CONCAT(v.mailbox,'@',v.context) " . $where;

	return DBQuery ($sql,$conn);
}

function SipUser_DBInsert($conn, $user)
{
	$sql = "INSERT INTO sip_buddies SET name='$user->name',accountcode='$user->accountcode',amaflags='$user->amaflags',".
			"callgroup='$user->callgroup',callerid='$user->callerid',canreinvite='$user->canreinvite',".
			"context='$user->context',defaultip='$user->defaultip',dtmfmode='$user->dtmfmode',fromuser='$user->fromuser',".
			"fromdomain='$user->fromdomain',host='$user->host',insecure='$user->insecure',language='$user->language',".
			"mailbox='$user->mailbox',md5secret='$user->md5secret',nat='$user->nat',permit='$user->permit',".
			"deny='$user->deny',mask='$user->mask',pickupgroup='$user->pickupgroup',port='$user->port',".
			"qualify='$user->qualify',restrictcid='$user->restrictcid',rtptimeout='$user->rtptimeout',".
			"rtpholdtimeout='$user->rtpholdtimeout',secret='$user->secret',type='$user->type',username='$user->username',".
			"disallow='$user->disallow',allow='$user->allow',musiconhold='$user->musiconhold',regseconds='$user->regseconds',".
			"ipaddr='$user->ipaddr',regexten='$user->regexten',cancallforward='$user->cancallforward'";
	$result = DBQuery ($sql,$conn) or die(DBErrorMsg());
	$user->id = DBInsertID($conn);

	if ($user->id > 0) {
		$fields = explode('@', $user->mailbox);
		$vm_mailbox=$fields[0];
		$vm_context=$fields[1];
		$result = DBQuery ("INSERT INTO voicemail_users SET customer_id='$user->vm_customer_id',context='$vm_context',mailbox='$vm_mailbox',password='$user->secret',".
				"fullname='$user->vm_fullname',email='$user->vm_email',pager='$user->vm_pager'",$conn) or die(DBErrorMsg());
	}
	return true;
}

function SipUser_DBUpdate($conn, $user)
{
	$sql = "UPDATE sip_buddies SET name='$user->name',accountcode='$user->accountcode',amaflags='$user->amaflags',".
			"callgroup='$user->callgroup',callerid='$user->callerid',canreinvite='$user->canreinvite',".
			"context='$user->context',defaultip='$user->defaultip',dtmfmode='$user->dtmfmode',fromuser='$user->fromuser',".
			"fromdomain='$user->fromdomain',host='$user->host',insecure='$user->insecure',language='$user->language',".
			"mailbox='$user->mailbox',md5secret='$user->md5secret',nat='$user->nat',permit='$user->permit',".
			"deny='$user->deny',mask='$user->mask',pickupgroup='$user->pickupgroup',port='$user->port',".
			"qualify='$user->qualify',restrictcid='$user->restrictcid',rtptimeout='$user->rtptimeout',".
			"rtpholdtimeout='$user->rtpholdtimeout',secret='$user->secret',type='$user->type',username='$user->username',".
			"disallow='$user->disallow',allow='$user->allow',musiconhold='$user->musiconhold',regseconds='$user->regseconds',".
			"ipaddr='$user->ipaddr',regexten='$user->regexten',cancallforward='$user->cancallforward'".
			" WHERE id='$user->id'";
	$result = DBQuery ($sql,$conn) or die(DBErrorMsg());
	
	$fields = explode('@', $user->mailbox);
	$vm_mailbox=$fields[0];
	$vm_context=$fields[1];
	if ($result && $user->vm_uid>0) {
		$result = DBQuery ("UPDATE voicemail_users SET customer_id='$user->vm_customer_id',context='$vm_context',mailbox='$vm_mailbox',password='$user->secret',".
				"fullname='$user->vm_fullname',email='$user->vm_email',pager='$user->vm_pager' WHERE uniqueid='$user->vm_uid'",$conn) or die(DBErrorMsg());
	} else if ($result && strlen($user->mailbox)>0) {
		$result = DBQuery ("INSERT INTO voicemail_users SET customer_id='$user->vm_customer_id',context='$vm_context',mailbox='$vm_mailbox',password='$user->secret',".
				"fullname='$user->vm_fullname',email='$user->vm_email',pager='$user->vm_pager'",$conn) or die(DBErrorMsg());
	}
	return true;
}

function VoiceMail_DBQry($conn, $where)
{
	$sql ="SELECT uniqueid,customer_id,context,mailbox,password,fullname,email,pager,stamp FROM voicemail_users " . $where;
	return DBQuery($sql, $conn);
}

function Extension_DBQry($conn, $where)
{
	$sql ="SELECT id,context,exten,priority,app,appdata FROM extensions " . $where. " ORDER BY context ASC, exten ASC, priority ASC";
	return DBQuery($sql, $conn);
}

function Extension_DBUpdate($conn, $ext)
{
	$sql ="UPDATE extensions SET context='$ext->context',exten='$ext->exten',priority='$ext->priority',app='$ext->app',appdata='$ext->appdata' WHERE id='$ext->id'";
	return DBQuery($sql, $conn);
}

function Extension_DBInsert($conn, $ext)
{
	$sql ="INSERT INTO extensions SET context='$ext->context',exten='$ext->exten',priority='$ext->priority',app='$ext->app',appdata='$ext->appdata'";
	return DBQuery($sql, $conn);
}

function Extension_DBDelete($conn, $ext)
{
	$sql ="DELETE FROM extensions WHERE id='$ext->id'";
	return DBQuery($sql, $conn);
}

?>
