<?php
/* SipUser Class
 *
 * Created By David Cornewell
*/


class SipUser {
	var $id            ;
	var $name          ;
	var $accountcode   ;
	var $amaflags      ;
	var $callgroup     ;
	var $callerid      ;
	var $canreinvite   ;
	var $context       ;
	var $defaultip     ;
	var $dtmfmode      ;
	var $fromuser      ;
	var $fromdomain    ;
	var $host          ;
	var $insecure      ;
	var $language      ;
	var $mailbox       ;
	var $md5secret     ;
	var $nat           ;
	var $permit        ;
	var $deny          ;
	var $mask          ;
	var $pickupgroup   ;
	var $port          ;
	var $qualify       ;
	var $restrictcid   ;
	var $rtptimeout    ;
	var $rtpholdtimeout;
	var $secret        ;
	var $type          ;
	var $username      ;
	var $disallow      ;
	var $allow         ;
	var $musiconhold   ;
	var $regseconds    ;
	var $ipaddr        ;
	var $regexten      ;
	var $cancallforward;

	var $vm_email;
	var $vm_fullname;
	var $vm_pager;
	var $vm_uid;
	var $vm_customer_id;
	var $vm_stamp;

	var $result		;

//thinking of having this just go ahead and DBGet it if the id is >0
// will think it over
	function SipUser() //$user_id
	{
		$this->result = null;
		return;
	}

	function Destroy()
	{
		if ($this->result) {
			DBFreeResult($this->result);
		}
	}
		
	function DBNext()
	{
		if ($this->result) {
			$row = DBGetRow($this->result);
			if ($row) {
				$this->id             = $row["id"];
				$this->name           = $row["name"];
				$this->accountcode    = $row["accountcode"];
				$this->amaflags       = $row["amaflags"];
				$this->callgroup      = $row["callgroup"];
				$this->callerid       = $row["callerid"];
				$this->canreinvite    = $row["canreinvite"];
				$this->context        = $row["context"];
				$this->defaultip      = $row["defaultip"];
				$this->dtmfmode       = $row["dtmfmode"];
				$this->fromuser       = $row["fromuser"];
				$this->fromdomain     = $row["fromdomain"];
				$this->host           = $row["host"];
				$this->insecure       = $row["insecure"];
				$this->language       = $row["language"];
				$this->mailbox        = $row["mailbox"];
				$this->md5secret      = $row["md5secret"];
				$this->nat            = $row["nat"];
				$this->permit         = $row["permit"];
				$this->deny           = $row["deny"];
				$this->mask           = $row["mask"];
				$this->pickupgroup    = $row["pickupgroup"];
				$this->port           = $row["port"];
				$this->qualify        = $row["qualify"];
				$this->restrictcid    = $row["restrictcid"];
				$this->rtptimeout     = $row["rtptimeout"];
				$this->rtpholdtimeout = $row["rtpholdtimeout"];
				$this->secret         = $row["secret"];
				$this->type           = $row["type"];
				$this->username       = $row["username"];
				$this->disallow       = $row["disallow"];
				$this->allow          = $row["allow"];
				$this->musiconhold    = $row["musiconhold"];
				$this->regseconds     = $row["regseconds"];
				$this->ipaddr         = $row["ipaddr"];
				$this->regexten       = $row["regexten"];
				$this->cancallforward = $row["cancallforward"];
				
				$this->vm_email			= $row["email"];      
				$this->vm_fullname		= $row["fullname"];   
				$this->vm_pager			= $row["pager"];      
				$this->vm_uid				= $row["uniqueid"];
				$this->vm_customer_id	= $row["customer_id"];
				$this->vm_stamp			= $row["stamp"];      
				return 1;
			}
		}
		return 0;
	}

	function DBGet($conn, $where)
	{
		$this->result = SipUser_DBQry($conn, $where);
/*		if ($this->result) {
			$num = DBNumRows($this->result);
			if ($num > 0) {
				$this->DBNext();
			}
		}
*/
		return;
	}
		
	function CgiGet($cgi)
	{
		$this->id             = $_REQUEST["id"];						//$cgi->var_val
		$this->name           = $_REQUEST["name"];               //$cgi->var_val
		$this->accountcode    = $_REQUEST["accountcode"];        //$cgi->var_val
		$this->amaflags       = $_REQUEST["amaflags"];           //$cgi->var_val
		$this->callgroup      = $_REQUEST["callgroup"];          //$cgi->var_val
		$this->callerid       = $_REQUEST["callerid"];           //$cgi->var_val
		$this->canreinvite    = $_REQUEST["canreinvite"];        //$cgi->var_val
		$this->context        = $_REQUEST["context"];            //$cgi->var_val
		$this->defaultip      = $_REQUEST["defaultip"];          //$cgi->var_val
		$this->dtmfmode       = $_REQUEST["dtmfmode"];           //$cgi->var_val
		$this->fromuser       = $_REQUEST["fromuser"];           //$cgi->var_val
		$this->fromdomain     = $_REQUEST["fromdomain"];         //$cgi->var_val
		$this->host           = $_REQUEST["host"];               //$cgi->var_val
		$this->insecure       = $_REQUEST["insecure"];           //$cgi->var_val
		$this->language       = $_REQUEST["language"];           //$cgi->var_val
		$this->mailbox        = $_REQUEST["mailbox"];            //$cgi->var_val
		$this->md5secret      = $_REQUEST["md5secret"];          //$cgi->var_val
		$this->nat            = $_REQUEST["nat"];                //$cgi->var_val
		$this->permit         = $_REQUEST["permit"];             //$cgi->var_val
		$this->deny           = $_REQUEST["deny"];               //$cgi->var_val
		$this->mask           = $_REQUEST["mask"];               //$cgi->var_val
		$this->pickupgroup    = $_REQUEST["pickupgroup"];        //$cgi->var_val
		$this->port           = $_REQUEST["port"];               //$cgi->var_val
		$this->qualify        = $_REQUEST["qualify"];            //$cgi->var_val
		$this->restrictcid    = $_REQUEST["restrictcid"];        //$cgi->var_val
		$this->rtptimeout     = $_REQUEST["rtptimeout"];         //$cgi->var_val
		$this->rtpholdtimeout = $_REQUEST["rtpholdtimeout"];     //$cgi->var_val
		$this->secret         = $_REQUEST["secret"];             //$cgi->var_val
		$this->type           = $_REQUEST["type"];               //$cgi->var_val
		$this->username       = $_REQUEST["username"];           //$cgi->var_val
		$this->disallow       = $_REQUEST["disallow"];           //$cgi->var_val
		$this->allow          = $_REQUEST["allow"];              //$cgi->var_val
		$this->musiconhold    = $_REQUEST["musiconhold"];        //$cgi->var_val
		$this->regseconds     = $_REQUEST["regseconds"];         //$cgi->var_val
		$this->ipaddr         = $_REQUEST["ipaddr"];             //$cgi->var_val
		$this->regexten       = $_REQUEST["regexten"];           //$cgi->var_val
		$this->cancallforward = $_REQUEST["cancallforward"];     //$cgi->var_val

		$this->vm_email			= $_REQUEST["vm_email"];      
		$this->vm_fullname		= $_REQUEST["vm_fullname"];   
		$this->vm_pager			= $_REQUEST["vm_pager"];      
		$this->vm_uid				= $_REQUEST["vm_uid"];        
		$this->vm_customer_id	= $_REQUEST["vm_customer_id"];
		$this->vm_stamp			= $_REQUEST["vm_stamp"];      
	}
}

//
// Should more of this be in the class?
//
function SipUser_DisplayForm($cgi, $user)
{
   $cgi->print_form(false, "method=get");
	$cgi->print_hidden();
?>
	<input type=hidden name="id" value="<?php print $user->id; ?>">
	<table border=1 cellpadding=1 cellspacing=0 align=center>
	<tr>
	<tr>
	<td class=field>Name</td>
	<td class=value><input type=text name="name" value="<?php print $user->name; ?>"></td>
	</tr>

	<td class=field>Username</td>
	<td class=value><input type=text name="username" value="<?php print $user->username; ?>"></td>
	</tr>

	<tr>
	<td class=field>Caller ID</td>
	<td class=value><input type=text name="callerid" value="<?php print $user->callerid; ?>"></td>
	</tr>

	<tr>
	<td class=field>Context</td>
	<td class=value><input type=text name="context" value="<?php print $user->context; ?>"></td>
	</tr>
		
	<tr>
	<td class=field>DTMF Mode</td>
	<td class=value>
	<select name="dtmfmode">
	<option value="rfc2833" <?php if ($user->dtmfmode=="rfc2833") print "selected=true"; ?>>rfc2833</option>
	<option value="inband" <?php if ($user->dtmfmode=="inband") print "selected=true"; ?>>inband</option>
	<option value="info" <?php if ($user->dtmfmode=="info") print "selected=true"; ?>>info</option>
	</select>
	</td>
	</tr>

	<tr>
	<td class=field>Host</td>
	<td class=value><input type=text name="host" value="<?php print $user->host; ?>"></td>
	</tr>
	
	<tr>
	<td class=field>Mailbox</td>
	<td class=value><input type=text name="mailbox" value="<?php print $user->mailbox; ?>"></td>
	</tr>
	
	<tr>
	<td class=field>Secret</td>
	<td class=value><input type=text name="secret" value="<?php print $user->secret; ?>"></td>
	</tr>

	<tr>
	<td class=field>Nat</td>
	<td class=value>
	<select name="nat">
	<option value=""></option>
	<option value="yes" <?php if ($user->nat=="yes") print "selected=true"; ?> >yes</option>
	<option value="route" <?php if ($user->nat=="route") print "selected=true"; ?>>route</option>
	<option value="no" <?php if ($user->nat=="no") print "selected=true"; ?>>no</option>
	<option value="never" <?php if ($user->nat=="never") print "selected=true"; ?>>never</option>
	</select>
	</td>
	</tr>

	<tr>
	<td class=field>Qualify (Keep nat alive)</td>
	<td class=value>
	<input type=checkbox name="qualify" value="yes" <?php if ($user->qualify=="yes") print "checked"; ?>>
	</td>
	</tr>

	<tr class=subtitle><td colspan=2><input type=checkbox name=addvmail value="1" <?php if ($user->vm_uid>0) print "checked=true" ?> >Add a voicemail box?</td></tr>

	<tr>
	<td class=field>VM Full Name</td>
	<td class=value><input type=text name="vm_fullname" value="<?php print $user->vm_fullname; ?>"></td>
	</tr>
	<tr>
	<td class=field>VM email</td>
	<td class=value><input type=text name="vm_email" value="<?php print $user->vm_email; ?>"></td>
	</tr>
	<tr>
	<td class=field>VM pager</td>
	<td class=value><input type=text name="vm_pager" value="<?php print $user->vm_pager; ?>"></td>
	</tr>
	
	</table>
	
	<center><input type=submit name="save" value="Save"></center>
	<input type=hidden name="accountcode"    value="<?php print $user->accountcode; ?>">      
	<input type=hidden name="amaflags"       value="<?php print $user->amaflags; ?>">         
	<input type=hidden name="callgroup"      value="<?php print $user->callgroup; ?>">        
	<input type=hidden name="canreinvite"    value="<?php print $user->canreinvite; ?>">      
	<input type=hidden name="defaultip"      value="<?php print $user->defaultip; ?>">        
	<input type=hidden name="fromuser"       value="<?php print $user->fromuser; ?>">         
	<input type=hidden name="fromdomain"     value="<?php print $user->fromdomain; ?>">       
	<input type=hidden name="insecure"       value="<?php print $user->insecure; ?>">         
	<input type=hidden name="language"       value="<?php print $user->language; ?>">         
	<input type=hidden name="md5secret"      value="<?php print $user->md5secret; ?>">        
	<input type=hidden name="permit"         value="<?php print $user->permit; ?>">           
	<input type=hidden name="deny"           value="<?php print $user->deny; ?>">             
	<input type=hidden name="mask"           value="<?php print $user->mask; ?>">             
	<input type=hidden name="pickupgroup"    value="<?php print $user->pickupgroup; ?>">      
	<input type=hidden name="port"           value="<?php print $user->port; ?>">             
	<input type=hidden name="restrictcid"    value="<?php print $user->restrictcid; ?>">      
	<input type=hidden name="rtptimeout"     value="<?php print $user->rtptimeout; ?>">       
	<input type=hidden name="rtpholdtimeout" value="<?php print $user->rtpholdtimeout; ?>">   
	<input type=hidden name="type"           value="<?php print $user->type; ?>">             
	<input type=hidden name="disallow"       value="<?php print $user->disallow; ?>">         
	<input type=hidden name="allow"          value="<?php print $user->allow; ?>">            
	<input type=hidden name="musiconhold"    value="<?php print $user->musiconhold; ?>">      
	<input type=hidden name="regseconds"     value="<?php print $user->regseconds; ?>">       
	<input type=hidden name="ipaddr"         value="<?php print $user->ipaddr; ?>">           
	<input type=hidden name="regexten"       value="<?php print $user->regexten; ?>">         
	<input type=hidden name="cancallforward" value="<?php print $user->cancallforward; ?>">   
	
	<input type=hidden name="vm_uid"         value="<?php print $user->vm_uid; ?>">
	<input type=hidden name="vm_customer_id" value="<?php print $user->vm_customer_id; ?>">
	<input type=hidden name="vm_stamp"       value="<?php print $user->vm_stamp; ?>">
	</form>
<?php
	return;
}

function SipUserAdd($loginsession) 
{
	$user = new SipUser();

	$user->CgiGet($loginsession->cgi);
		
	if ($_REQUEST[save]) {
		if (strlen($user->name)) {
			if (SipUser_DBInsert($loginsession->conn, $user) == true) {
				print "Added user " . $user->name;
			} else {
				print "Error adding user! " . DBerrormsg();
				SipUser_DisplayForm($loginsession->cgi, $user);
			}
		} else {
			print "Must enter a name";
			SipUser_DisplayForm($loginsession->cgi, $user);
		}
	} else {
		SipUser_DisplayForm($loginsession->cgi, $user);
	}
}

function SipUserEdit($loginsession) 
{
	$user = new SipUser();
	$id=$_REQUEST['id'];

	if ($loginsession->login_user->id!=-1 && $loginsession->login_user->id!=$id) {
		print "you do not have access to edit other accounts";
		return;
	}
	
	if ($_REQUEST[save]) {
		$user->CgiGet($loginsession->cgi);
		
		if (strlen($user->username) && strlen($user->name)) {
			if (SipUser_DBUpdate($loginsession->conn, $user) == true) {
				print "Updated user " . $user->username . " " . $user->name;
			} else {
				print "Error updating user! " . DBerrormsg();
				SipUser_DisplayForm($loginsession->cgi, $user);
			}
		} else {
			print "Must enter a first and last name";
			SipUser_DisplayForm($loginsession->cgi, $user);
		}
	} else {
		$user->DBGet($loginsession->conn, "WHERE s.id='".$id."'");
		if ($user->DBNext()) {
			SipUser_DisplayForm($loginsession->cgi, $user);
		} else {
			print "Error getting id: ".$_REQUEST['id'];
		}
	}
}

function SipUserList($loginsession)
{
	$user = new SipUser();
?>
	<table border=1 cellpadding=1 cellspacing=0 align=center width="98%">
	<tr class=title>
		<td colspan=4>Users</td>
	</tr>
	<tr class=subtitle>
		<th>Name</th>
		<th>Caller Id</th>
		<th>Username</th>
		<th>Options</th>
	</tr>
	
<?php
	if ($loginsession->login_user->id==-1) {
		$user->DBGet($loginsession->conn, "ORDER BY name");
	} else {
		$user->DBGet($loginsession->conn, "WHERE id='". $loginsession->login_user->id ."'");
	}
	$i=0;
	while ($user->DBNext()) {
		if ($i%3==0) $selclass="altvalue";
		else $selclass="value";
		
		print "<tr align=center class=$selclass>";
		print "<td>$user->name</td>\n";
		print "<td>$user->callerid</td>\n";
		print "<td>$user->username</td>\n";
		print "<td><a class=$selclass href=\"".$loginsession->cgi->generate_uri(0)."&amp;opp=edit&amp;id=$user->id\">Edit</a></td>\n";
		print "</tr>\n";
		$i++;
	}
?>

	</table>
<?php
	return;
}

function SipUserHandler($loginsession)
{

?>
	<div align=right style="padding-right: 15">
	<a class=folder href="<?php echo $loginsession->cgi->generate_uri(0); ?>&opp=add">Add SipUser</a>
	</div>
<?php

	$opp = $loginsession->cgi->var_val("opp");
	$loginsession->cgi->forward(array("opp"));
	if ($opp=="add") {
		SipUserAdd($loginsession);
	} else if ($opp=="edit") {
		SipUserEdit($loginsession);
	}// else {
		SipUserList($loginsession);
//	}

	return;
}

?>
